unit paramUnit;
{
 handle parameters
}

interface

uses windows,ovUnit,unit1,stdctrls,sysutils,graphics,classes,dialogs;

type TmouseAction = (maDown,maMove,maUp);
     
const ff = '#0.000';   //floating point format

var ABEdit      : array[1..24] of Tedit; //rectangle x1,y1,...x4,y4

    Rtop    : TRealPoint;               //right top coordinates
    LBottom : TrealPoint;               //left bottom coordinates
    xyScale : double = 1;               //value per 20 pixels
    
    map1       : Tbitmap;
    map2       : Tbitmap;

    MouseAction : TMouseAction;
    mouseX      : integer;
    mouseY      : integer;
    mouseCount  : byte;

    ABselect    : ^TPoly12;  //select A or B coords in edit

procedure initParams;
function pixeltoX(px : integer) : double;
function pixeltoY(py : integer) : double;
function XtoPixel(dx : double) : integer;
function YtoPixel(dy : double) : integer;
procedure paintPoly(var pr : TPoly12;col:longInt);
procedure map2ToBox;
procedure createMaps;
procedure freeMaps;
procedure MouseProc;
procedure paintShowPolys;
procedure TopBotTotext;
procedure polyToEdit;
procedure EditToPoly;
procedure newscale;
procedure NewAangles;
procedure NewBangles;
procedure selectA;
procedure selectB;
procedure makeApoly;
procedure makeBpoly;

implementation

function EditError(var v : double;e : Tedit) : boolean;forward;
procedure buildmap2;forward;

procedure initparams;
begin
 decimalseparator := '.';
 form1.Aanglesselect.itemindex := 0;
 form1.Banglesselect.itemindex := 0;
 form1.scalebox.itemindex := 3;
 with Lbottom do
  begin
   x := 0; y := 0;
  end;
 with Rtop do
  begin
   x := (map2.width div 20);
   y := (map2.height div 20);
  end;
 with form1.scalebox do xyscale := strtofloat(items[itemindex]);
 TopBotToText;
 makeApoly;
 makeBpoly;
 selectA;
 paintshowpolys;
end;

procedure newscale;
//new scale factor was selected
begin
 xyscale := strtofloat(form1.scalebox.text);
 LBottom.x := 0;
 LBottom.y := 0;
 Rtop.x := Lbottom.x + 40 * xyscale;
 Rtop.y := Lbottom.y + 25 * xyscale;
 topbottotext;
 paintshowpolys;
end;

procedure NewAangles;
begin
 makeApoly;
 selectA;
 paintshowpolys;
end;

procedure NewBangles;
begin
 makeBpoly;
 selectB;
 paintshowpolys;
end;

procedure selectA;
//select Apoints, set ABselect,copy coords
begin
 ABselect := @Apoints;
 form1.AtextBtn.down := true;
 polyToEdit;
end;

procedure selectB;
//select Apoints, set ABselect,copy coords
begin
 ABselect := @Bpoints;
 form1.BtextBtn.down := true;
 polyToEdit;
end;

//---- variables to Edit text -----

procedure TopBotToText;
//do not check
//adjust for geo / test mode
begin
 with form1 do
  begin
   xtoptext.caption := formatfloat(ff,RTop.x);
   ytoptext.caption := formatfloat(ff,RTop.y);
   xBotText.caption := formatfloat(ff,LBottom.x);
   yBotText.caption := formatfloat(ff,LBottom.y);
  end; 
end;

function EditError(var v : double;e : Tedit) : boolean;
//check Editbox for valid double, convert text to v
//exit: true if error
begin
 try
  v := strtofloat(e.text);
  result := false;
 except
  result := true;
 end; 
end;

//-------- scale calculations ---------

function pixeltoX(px : integer) : double;
begin
 result:= LBottom.X + (px / (map1.width-1)) * (Rtop.x - LBottom.x);
end;

function pixeltoY(py : integer) : double;
begin
 result:= LBottom.Y + ((map1.height-1-py) / (map1.height-1)) * (Rtop.y - LBottom.y);
end;

function XtoPixel(dx : double) : integer;
begin
 result := trunc((dx-LBottom.x)/(RTop.x-Lbottom.x)*(map1.width-1)+0.5);
end;

function YtoPixel(dy : double) : integer;
begin
 result := trunc((1-(dy-LBottom.y)/(RTop.y-Lbottom.y))*(map1.height-1)+0.5);
end;

//--------- buttons -------- edits -------------

procedure polyToEdit;
//copy poly12 to edit boxes
//ABselect is Apoints or Bpoints
var i : byte;
begin
 for i := 1 to 12 do
  begin
   if i <= ABselect.angles then
    begin
     ABEdit[2*i-1].visible := true;
     ABEdit[2*i].visible := true;
     ABEdit[2*i-1].text := formatfloat(ff,ABselect.coord[i].x);
     ABEdit[2*i].text := formatfloat(ff,ABselect.coord[i].y);
    end
   else
    begin
     ABEdit[2*i-1].visible := false;
     ABEdit[2*i].visible := false;
    end;
  end;//for
end;

procedure EditToPoly;
//A,B,textbutton selects poly
//poly.angles holds # angles
//set A,B edit to false,true
var p : ^TPoly12;
    dv : array[1..24] of double;
    i : byte;
begin
 if form1.AtextBtn.down then p := @APoints
  else p := @Bpoints;
 for i := 1 to 2* p.angles do
  if EditError(dv[i],ABEdit[i]) then
   begin
    msg(msgError,'edit error');
    exit;
   end;
 msg(msgMessage,'edit OK');
//
 for i := 1 to p.angles do
  begin
   p.coord[i].x := dv[2*i-1];
   p.coord[i].y := dv[2*i];
  end;
 AposOk := testconvex(Apoints);
 BposOk := testconvex(Bpoints);//====
 paintshowpolys; 
end;

//------ make, paint polygon -----------

procedure makeApoly;
var da,ofs : single;
    r : single;
    x,y : double;
    i : byte;
begin
 x := pixeltoX(8*35);
 y := pixeltoY(12*20);
 r := pixeltoX(10*20) - pixeltox(0);
 with form1.AanglesSelect do
  Apoints.angles := strtoint(items[itemindex]);
 da := 2*pi/Apoints.angles;
 ofs := pi*(Apoints.angles+2)/(2*Apoints.angles);
 for i := 1 to Apoints.angles do
  begin
   Apoints.coord[i].x := x + r*cos((i-1)*da - ofs);
   Apoints.coord[i].y := y + r*sin((i-1)*da - ofs);
  end;
 AposOK := true;
end;

procedure makeBpoly;
var da,ofs : single;
    r : single;
    x,y : double;
    i : byte;
begin
 x := pixeltoX(8*65);
 y := pixeltoY(12*20);
 r := pixeltoX(10*20) - pixeltox(0);
 with form1.BanglesSelect do
  Bpoints.angles := strtoint(items[itemindex]);
 da := 2*pi/Bpoints.angles;
 ofs := pi*(Bpoints.angles+2)/(2*Bpoints.angles);
 for i := 1 to bpoints.angles do
  begin
   Bpoints.coord[i].x := x + r*cos((i-1)*da-ofs);
   Bpoints.coord[i].y := y + r*sin((i-1)*da-ofs);
  end;
 BposOK := true; 
end;

procedure paintPoly(var pr : TPoly12;col:longInt);
//paint polygon pr in map2 with color col
var xx,yy,xx1,yy1 : integer;
    i : byte;
begin
 with map2 do with canvas do
  begin
   brush.style := bsClear;
   pen.width := 2;
   pen.color := col;
   xx1:= XtoPixel(pr.coord[1].x);
   yy1 := YtoPixel(pr.coord[1].y);
   textout(xx1+5,yy1,'1');
   moveto(xx1,yy1);
   for i := 2 to pr.angles do
    begin
     xx := XtoPixel(pr.coord[i].x);
     yy := YtoPixel(pr.coord[i].y);
     lineto(xx,yy);
     textout(xx+5,yy,inttostr(i));
     moveto(xx,yy);
    end;
   lineto(xx1,yy1);
   brush.style := bsSolid;
   brush.color := col;
   for i := 1 to pr.angles do
    begin
     xx := XtoPixel(pr.coord[i].x);
     yy := YtoPixel(pr.coord[i].y);
     fillrect(rect(xx-4,yy-4,xx+4,yy+4));
    end;
  end;//with
end;

// -----------------

procedure paintShowPolys;
//paint poly A,B in map 2 and copy to paintbox
//do not paint if edits are not OK
var col : LongInt;
begin
 buildmap2;
 if APosOK then col := $ff0000 else col := $ffc0c0;
 paintpoly(Apoints,col);
 if BPosOK then col := $0000ff else col := $c0c0ff;
 paintpoly(Bpoints,col);
 map2tobox;
end;

function onPoint(p : TPoly12) : byte;
//return index of point in Poly
//0 if no point
var i : byte;
    hit : boolean;
    px,py : integer;
begin
 i := 0;
 repeat
  inc(i);
  px := XtoPixel(p.coord[i].x);
  py := YToPixel(p.coord[i].y);
  hit := (abs(px-mouseX) < 5) and (abs(py - mouseY) < 5);
 until hit or (i = p.angles);
 if hit then result := i else result := 0;
end;

function GetSelRect(v : Trealpoint) : Trect;
var x,y : integer;
begin
 x := XtoPixel(v.x)-4;
 y := YToPixel(v.y)-4;
 result.left := x - 1;
 result.right := result.left + 12;
 result.top := y - 1;
 result.bottom := result.top + 12;
end;

procedure eraseRect(v : TRealpoint);
//erase rectangle around selected point
var r : Trect;
begin
 r := GetSelRect(v);
 form1.paintbox1.canvas.copyrect(r,map2.canvas,r);
end;

procedure shiftPoints(var p : TPoly12; pnt : byte; x,y : integer);
//shift poly p point pnt to (x,y), shift other points accordingly
var i : byte;
    dx,dy : double;
begin
 dx := pixeltoX(x) - p.coord[pnt].x;
 dy := pixeltoY(y) - p.coord[pnt].y;
 for i := 1 to p.angles do
  begin
   p.coord[i].x := p.coord[i].x + dx;
   p.coord[i].y := p.coord[i].y + dy;
  end;
end;

procedure paintSelRect(v : TRealpoint);
//paint rectangle around selected point;
var r : Trect;
begin
 r := GetSelRect(v);
 with form1.paintbox1.Canvas do
  begin
   pen.color := $ff00ff;
   pen.width := 2;
   moveto(r.left+1,r.top+1);
   lineto(r.left+1,r.bottom-2);
   lineto(r.right-2,r.bottom-2);
   lineto(r.right-2,r.top+1);
   lineto(r.left,r.top);
  end; 
end;

// ---------- mouse Actions

procedure MouseProc;
//handle mouse actions
//mouseCount 0 : moving , Up
//           1 : over angle
//           2 : down on angle
//           3 : down + moved
const p : byte = 0;
begin
 case mouseAction of
  maMove : begin
            case mouseCount of
             0,
             1 : case mainbutton of
                  mbModA,
                  mbShiftA  : begin
                              if p <> 0 then eraseRect(APoints.coord[p]);
                              p := onPoint(APoints);
                              if p > 0 then
                               begin
                                mouseCount := 1;
                                paintSelRect(APoints.coord[p]);
                               end
                               else mouseCount := 0;
                             end;
                  mbModB,
                  mbShiftB : begin
                              if p <> 0 then eraseRect(BPoints.coord[p]);
                              p := onPoint(BPoints);
                              if p > 0 then
                               begin
                                mouseCount := 1;
                                paintSelRect(BPoints.coord[p]);
                               end
                               else mouseCount := 0;
                             end;
                 end;//case
             2 : mouseCount := 3;              //after mouse down
             3 : begin                         //plus moving
                  case mainbutton of
                    mbModA : begin
                              APoints.coord[p].x := PixelToX(mouseX);
                              APoints.coord[p].y := PixelToY(mouseY);
                              PolyToEdit;
                              AposOK := testConvex(Apoints);
                              if  APosOK then msg(msgMessage,'')
                               else msg(msgError,'A-shape error');//illegal A
                              paintShowpolys;
                              PaintSelRect(APoints.coord[p]);
                             end;
                   mbModB : begin
                             BPoints.coord[p].x := PixelToX(mouseX);
                             BPoints.coord[p].y := PixelToY(mouseY);
                             PolyToEdit;
                             BPosOK := testconvex(Bpoints);
                             if BPosOK then msg(msgMessage,'')
                               else msg(msgError,'B-shape error');//illegal B
                             paintShowpolys;
                             PaintSelRect(BPoints.coord[p]);
                            end;
                 mbShiftA : begin
                             shiftPoints(APoints,p,mouseX,mouseY);
                             PolyToEdit;
                             paintShowpolys;
                             Paintselrect(APoints.coord[p]);
                            end;
                 mbShiftB : begin
                             shiftPoints(BPoints,p,mouseX,mouseY);
                             polyToEdit;
                             paintShowpolys;
                             Paintselrect(BPoints.coord[p]);
                            end;
                   end;//case
                 end;
            end;//case
           end;//case ma move
  maDown : if mouseCount = 1 then mousecount := 2;
  maUp   : begin
            mouseCount := 0;
            p := 0;
           end;
 end;//case mouse action
end;

procedure map2ToBox;
begin
 form1.paintbox1.canvas.draw(0,0,map2);
end; 

//-------- bitmap creation -------------

procedure setmap(bm : Tbitmap);
//set bm to size of paintbox1 - 10
begin
 with bm do
  begin
   width := form1.paintbox1.width;
   height := form1.paintbox1.height;
   with canvas do
    begin
     font.name := 'arial';
     font.height := 18;
     font.color := $808080;
     brush.Style := bsClear;
    end;
  end;
end;

procedure buildmap1;
//copy also to map2
var i : integer;
begin
 with map1 do with canvas do
  begin
   brush.color := $f0ffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.width := 1;
   pen.color := $fff0f0;
   i := 0;
   while i < width do
    begin
     moveto(i,0);
     lineto(i,height);
     inc(i,20);
    end;
   i := 0;
   while i < height do
    begin
     moveto(0,i);
     lineto(width,i);
     inc(i,20);
    end;
  end;//with
end;

procedure buildmap2;
var i : byte;
    f : double;
begin
 with map2 do with canvas do
  begin
   draw(0,0,map1);
   pen.color := $ffe0e0;
   i := 0;
//
   while i <= 40 do                   //vertical
    begin
     f := abs(frac((LBottom.x + i * xyScale)/(5*xyscale)));
     if (f < 0.05) or (f > 0.95) then  
      begin
       moveto(i*20,0);
       lineto(i*20,height);
      end;
     inc(i);
    end;
//
   i := 0;
   while i <= 25 do                  //horizontal
    begin
     f := abs(frac((LBottom.y + i * xyScale)/(5*xyscale)));
     if  (f < 0.05) or (f > 0.95) then
      begin
       moveto(0,height-1-i*20);
       lineto(width,height-1-i*20);
      end;
     inc(i);
    end;
  end;//with  
end;

procedure createMaps;
begin
 map1 := Tbitmap.create;
 setmap(map1);
 map2 := Tbitmap.create;
 setmap(map2);
 buildmap1;
end;

procedure freeMaps;
begin
 map1.free;
 map2.free;
end;
  
end.
